diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
index 4d904140d..f83f3e1db 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidFlowing.java
@@ -2,7 +2,6 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.world.Dimension;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
@@ -34,7 +33,7 @@ public class BlockLogicFluidFlowing extends BlockLogicFluid
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         int localFlowDecay = getDepth(world, x, y, z);
         final byte flowDecayMod = this.fluid.getFlowDecayMod(this, world, x, y, z);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
index 978b7f131..b56befd43 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFluidStill.java
@@ -40,7 +40,7 @@ public class BlockLogicFluidStill extends BlockLogicFluid
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         this.fluid.updateTickStill(this, world, x, y, z, rand);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
index 59f78ec80..a3d26180a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicGrass.java
@@ -21,7 +21,7 @@ public class BlockLogicGrass extends BlockLogic
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isClientSide)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
index af17b0cb8..ac6be0555 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicIce.java
@@ -45,7 +45,7 @@ public class BlockLogicIce extends BlockLogicTransparent
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11 - block.lightBlock)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index a0393aad8..8fda1c95f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -3,6 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
@@ -18,7 +21,7 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public class BlockLogicJar extends BlockLogic {
+public class BlockLogicJar extends BlockLogic implements ISupportable {
 
     private final Supplier<Item> itemSupplier;
     public BlockLogicJar(Block<?> block, @NotNull Supplier<Item> itemSupplier) {
@@ -31,12 +34,10 @@ public class BlockLogicJar extends BlockLogic {
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        if(!world.canPlaceOnSurfaceOfBlock(x, y - 1, z))
-        {
-            return false;
-        } else
-        {
+        if (isSupported(world, x, y, z, Side.BOTTOM)) {
             return super.canPlaceBlockAt(world, x, y, z);
+        } else {
+            return false;
         }
     }
 
@@ -51,6 +52,12 @@ public class BlockLogicJar extends BlockLogic {
     {
         return false;
     }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side == Side.BOTTOM ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
@@ -133,4 +140,8 @@ public class BlockLogicJar extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE.center();
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index eba3aa260..359b33fd2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -3,6 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityJarButterfly;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.animal.MobButterfly;
 import net.minecraft.core.entity.player.Player;
@@ -17,7 +20,7 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public class BlockLogicJarButterfly extends BlockLogic {
+public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     public static final int MASK_HANGING = 0b0000_0001;
     public static final int MASK_ANGLED = 0b0000_0010;
     private final Supplier<Item> itemSupplier;
@@ -51,6 +54,11 @@ public class BlockLogicJarButterfly extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
         world.setBlockRaw(x, y, z, 0);
@@ -65,26 +73,26 @@ public class BlockLogicJarButterfly extends BlockLogic {
 
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))) {
+        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))) {
             world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
             return;
         }
-        if ((side == Side.TOP || (side != Side.BOTTOM && yPlaced < 0.5d)) && (world.canPlaceOnSurfaceOfBlock(x, y - 1, z))) {
+        if ((side == Side.TOP || (side != Side.BOTTOM && yPlaced < 0.5d)) && isSupported(world, x, y, z, Side.BOTTOM)) {
             world.setBlockMetadataWithNotify(x, y, z, 0);
             return;
         }
-        if (world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
             world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
         } else world.setBlockMetadataWithNotify(x, y, z, 0);
     }
 
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z) {
-        if (world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return isSupported(world, x, y, z, Side.BOTTOM);
     }
 
     @Override
@@ -111,10 +119,10 @@ public class BlockLogicJarButterfly extends BlockLogic {
     public boolean canBlockStay(World world, int x, int y, int z) {
         int meta = world.getBlockMetadata(x, y, z);
         if ((meta & MASK_HANGING) != 0) {
-            return world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
+            return isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
         }
 
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return isSupported(world, x, y, z, Side.BOTTOM);
     }
 
     @Override
@@ -135,4 +143,8 @@ public class BlockLogicJarButterfly extends BlockLogic {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index 067eccb4c..fa135f0fb 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -1,13 +1,18 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
-public class BlockLogicLadder extends BlockLogic {
+public class BlockLogicLadder extends BlockLogic implements ISupportable {
 
 	public BlockLogicLadder(Block<?> block) {
 		super(block, Material.wood);
@@ -27,7 +32,12 @@ public class BlockLogicLadder extends BlockLogic {
 	public boolean isClimbable(World world, int x, int y, int z) {
 		return true;
 	}
-	
+
+	@Override
+	public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+		return PartialSupport.INSTANCE;
+	}
+
 	@Override
 	public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z) {
 		Side side = getSideFromMeta(world.getBlockMetadata(x, y, z));
@@ -83,12 +93,7 @@ public class BlockLogicLadder extends BlockLogic {
 	
 	public boolean canExistAt(World world, int x, int y, int z, int meta) {
 		Side side = getSideFromMeta(meta).getOpposite();
-		
-		x += side.getOffsetX();
-		y += side.getOffsetY();
-		z += side.getOffsetZ();
-		
-		return world.isBlockNormalCube(x, y, z);
+		return isSupported(world, x, y, z, side);
 	}
 
 	/**
@@ -109,5 +114,9 @@ public class BlockLogicLadder extends BlockLogic {
 		if(side == Side.EAST) return 5;
 		return 0;
 	}
-	
+
+	@Override
+	public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+		return FullSupport.INSTANCE;
+	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
index e85ac1ade..e928b7959 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
@@ -2,6 +2,9 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.ISupportable;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
 import net.minecraft.core.entity.player.Player;
@@ -17,7 +20,7 @@ import org.jetbrains.annotations.NotNull;
 import java.util.Random;
 import java.util.function.Supplier;
 
-public class BlockLogicLanternFirefly extends BlockLogic {
+public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable {
     public static final int MASK_HANGING = 0b0000_0001;
     public static final int MASK_ANGLED = 0b0000_0010;
     private final Supplier<Item> itemSupplier;
@@ -52,6 +55,11 @@ public class BlockLogicLanternFirefly extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public void animationTick(World world, int x, int y, int z, Random rand)
     {
@@ -76,28 +84,29 @@ public class BlockLogicLanternFirefly extends BlockLogic {
     }
     @Override
     public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (world.isBlockNormalCube(x, y+1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
+        if ((side == Side.BOTTOM || (side != Side.TOP && yPlaced >= 0.5d)) && (isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))){
             world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
             return;
         }
-        if ((side == Side.TOP || (side != Side.BOTTOM && yPlaced < 0.5d)) && (world.canPlaceOnSurfaceOfBlock(x, y-1, z))){
+        if ((side == Side.TOP || (side != Side.BOTTOM && yPlaced < 0.5d)) && isSupported(world, x, y, z, Side.BOTTOM)){
             world.setBlockMetadataWithNotify(x, y, z, 0);
             return;
         }
-        if(world.isBlockNormalCube(x, y+1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF))
-        {
+        if (isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
             world.setBlockMetadataWithNotify(x, y, z, MASK_HANGING);
-        } else world.setBlockMetadataWithNotify(x, y, z, 0);
+        } else {
+            world.setBlockMetadataWithNotify(x, y, z, 0);
+        }
     }
 
     @Override
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
-        if(world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
+        if(isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return isSupported(world, x, y, z, Side.BOTTOM);
     }
 
     @Override
@@ -129,10 +138,10 @@ public class BlockLogicLanternFirefly extends BlockLogic {
     {
         int meta = world.getBlockMetadata(x, y, z);
         if((meta & MASK_HANGING) != 0) {
-            return world.isBlockNormalCube(x, y + 1, z) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
+            return isSupported(world, x, y, z, Side.TOP) || Blocks.hasTag(world.getBlockId(x, y + 1, z), BlockTags.CAN_HANG_OFF);
         }
 
-        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+        return isSupported(world, x, y, z, Side.BOTTOM);
     }
     
     @Override
@@ -155,4 +164,9 @@ public class BlockLogicLanternFirefly extends BlockLogic {
     public int getPistonPushReaction(World world, int x, int y, int z) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
+
+    @Override
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side.isVertical() ? PartialSupport.INSTANCE.center() : PartialSupport.INSTANCE;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
index b50b13458..71ca9440d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerBase.java
@@ -1,13 +1,20 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.item.block.ItemBlockLayer;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public abstract class BlockLogicLayerBase extends BlockLogic
 {
     public Block<?> fullBlock = null;
+    public static final int MASK_HEIGHT = 0b111;
 	
 	public BlockLogicLayerBase(Block<?> block, Block<?> fullBlock, Material material)
     {
@@ -29,10 +36,27 @@ public abstract class BlockLogicLayerBase extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        int height = world.getBlockMetadata(x, y, z) & MASK_HEIGHT;
+        switch (side) {
+            case TOP: return PartialSupport.INSTANCE;
+            case BOTTOM: return FullSupport.INSTANCE;
+            default:
+                if (height >= 5) {
+                    return PartialSupport.INSTANCE.center().down();
+                } else if (height >= 1) {
+                    return PartialSupport.INSTANCE.down();
+                } else {
+                    return PartialSupport.INSTANCE;
+                }
+        }
+    }
+
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        int l = world.getBlockMetadata(x, y, z) & 7;
+        int l = world.getBlockMetadata(x, y, z) & MASK_HEIGHT;
         float f = (float)(2 * (1 + l)) / 16F;
         return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, f, 1.0F);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index 6c7f4960d..8bb44f900 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -88,7 +88,7 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
     	if (world.getSeasonManager().getCurrentSeason() != null && !world.getSeasonManager().getCurrentSeason().hasFallingLeaves)
     	{
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index 54ee250b7..5e8c2babe 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -5,7 +5,6 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.enums.LightLayer;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
@@ -90,7 +89,7 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
 		if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11)
 		{
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
index 2d263ad95..64b32c95c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
@@ -11,7 +11,6 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.season.Season;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -86,7 +85,7 @@ public class BlockLogicLeavesBase extends BlockLogic
         }
     }
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand)
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isClientSide)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
index 6314b44be..cde5c7f21 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
@@ -89,8 +89,8 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
     }
 
     @Override
-    public void updateTick(World world, int x, int y, int z, Random rand) {
-        super.updateTick(world, x, y, z, rand);
+    public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         int meta = world.getBlockMetadata(x, y, z);
         int growthRate = getGrowthRate(meta);
         if (rand.nextInt(BEAN_GROWTH_RATE) == 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index 9bf773bc7..d9060508e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -73,8 +73,8 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand) {
-        super.updateTick(world, x, y, z, rand);
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick) {
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         int meta = world.getBlockMetadata(x, y, z);
         int growthRate = getGrowthRate(meta);
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
index 699fc0242..70eed32b8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesOak.java
@@ -14,9 +14,9 @@ public class BlockLogicLeavesOak extends BlockLogicLeavesBase
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
-        super.updateTick(world, x, y, z, rand);
+        super.updateTick(world, x, y, z, rand, isRandomTick);
         if (rand.nextInt(128) == 0 && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().hasFallingLeaves)
         {
             for (int q = -1; q > -16; q--)
